
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <limits.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/md.h>

#define MDTAB_FILE "/etc/mdtab"

static FILE *tab=NULL;

void mdtab_open (void)
{
  if (!(tab=fopen (MDTAB_FILE, "r")))
  {
    perror (MDTAB_FILE);
    exit (EXIT_FAILURE);
  }
}
  
char **parser (char *md_dev, int number, int *personality)
{
  int c, pos, len, count=0, i=1;
  short factor;
  char line[256], dummy[256], options[256];
  static char *ent[10]; /* Max 9 dev/md */

  if (!tab)
    mdtab_open ();

  rewind (tab);
  
  while (!feof (tab))
  {
    /* Parse les espaces de debut */
    fscanf (tab, " ");

    /* Recherche de commentaires */
    while ((c=fgetc (tab))=='#')
      fscanf (tab, "%*[^\n] ");	/* Ignore toute la fin de la ligne */

    ungetc (c, tab);

    if (feof (tab))
      return NULL;
    
    /* Parse la ligne complete
       FIXME : Pas de ligne de plus de 255 caracteres */
    fscanf (tab, "%255[^#\n]", line);

    /* Parse le md_dev */
    ent[0]=(char *) malloc (256);
    sscanf (line, "%255[^ \t]%255[ \t]", ent[0], dummy);
    
    count++;
    if ((md_dev && strcmp (md_dev, ent[0])) ||
	(!md_dev && count<number))
    {
      free (ent[0]);
      continue;
    }

    len=strlen (line);
    pos=strlen (ent[0])+strlen (dummy)+1;

    sscanf (line+pos-1, "%255[^ \t]%255[ \t]", options, dummy);
    pos+=strlen (options)+strlen (dummy);

    sscanf (options, "%255[^,],%hd", dummy, &factor);

    *personality=0;
    
    if (!strcmp (dummy, "linear"))
      *personality=LINEAR;

    if (!strcmp (dummy, "stripped") || /* This spelling mistake will last... */
	!strcmp (dummy, "striped") ||
	!strcmp (dummy, "raid0"))
      *personality=STRIPPED | (factor & FACTOR_MASK);

    if (!*personality)
    {
      fprintf (stderr, "Unknown option %s\n", options);
      exit (EXIT_FAILURE);
    }
    
    while (pos<(len-1))
    {
      ent[i]=(char *) malloc (256);
      sscanf (line+pos-1, "%255[^ \t]%255[ \t]", ent[i], dummy);
      pos+=strlen (ent[i])+strlen (dummy);
      i++;
    }
    ent[i]=NULL;

    return (ent);
  }
  return (NULL);
}

